function lh = addSIGBARS(xvals,yvals,pvals,padscale,lwidth,fsize)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%FUNCTION  short descr.
% long descr.
%
% USAGE:
%         [out] = template(in,in2)
%
% INPUT:
%         in - input 1
%         in2 - input 2
%
% OUTPUT:
%    p - output
%
% EXAMPLES:
%
% See also: FUNCTION2 FUNCTION3

% HISTORY:
% version 1.0.0, Release 00/00/00 Initial release
%
% Author: Roddy Grieves
% UCL, 26 Bedford Way
% eMail: r.grieves@ucl.ac.uk
% Copyright 2018 Roddy Grieves

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% INPUT ARGUMENTS CHECK
if isempty(xvals)
    lh = NaN;
    return
end

% deal with input variables
inps = {'pvals','padscale','lwidth','fsize'};
vals = {mat2str(ones(size(xvals(:,1))).*0.5),'0.1','1','14'};
reqd = [0 0 0 0];
for ff = 1:length(inps)
    if ~exist(inps{ff},'var')
        if reqd(ff)
            error('ERROR: vargin %s missing... exiting',inps{ff});            
        end        
        eval([inps{ff} '=' vals{ff} ';']);
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% FUNCTION BODY
ax = gca;
padval = padscale*diff(ax.YLim);
tadval = (padscale/4)*diff(ax.YLim); 
lineys = [];
line_valsX = [];
line_valsY = [];
for bb = 1:length(xvals(:,1))
    yvs = yvals(xvals(bb,:));
    line_y = max([yvs yvals]) + padval;
    while ismember(line_y,lineys)
        line_y = line_y + padval;
    end
    line_valsX = [line_valsX (xvals(bb,:))'];
    line_valsY = [line_valsY ([line_y line_y])'];
    lineys(bb) = line_y;
    
    text_y = line_y + tadval;
    if pvals(bb)<=.001
        text(mean(xvals(bb,:)),text_y,'***','HorizontalAlignment','center','FontSize',fsize);
    elseif pvals(bb)<=.01
        text(mean(xvals(bb,:)),text_y,'**','HorizontalAlignment','center','FontSize',fsize);
    elseif pvals(bb)<=.05
        text(mean(xvals(bb,:)),text_y,'*','HorizontalAlignment','center','FontSize',fsize); 
    else
        tadval = (padscale/3)*diff(ax.YLim); 
        text_y = line_y + tadval;        
        text(mean(xvals(bb,:)),text_y,'n.s','HorizontalAlignment','center','FontSize',fsize);         
    end

end
lh = line(line_valsX,line_valsY,'Color','k','LineWidth',lwidth);
ax.YLim(2) = max(line_valsY(:)) + padval;






































































