function plotMAZE(fh,ah,maze,lindx)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ################################################################# %% DESCRIPTION
%FUNCTION  short descr.
% long descr.
%
% USAGE:
%         [out] = template(in,in2)
%
% INPUT:
%         in - input 1
%         in2 - input 2
%
% OUTPUT:
%    p - output
%
% EXAMPLES:
%
% See also: FUNCTION2 FUNCTION3

% HISTORY:
% version 1.0.0, Release 00/00/00 Initial release
%
% Author: Roddy Grieves
% UCL, 26 Bedford Way
% eMail: r.grieves@ucl.ac.uk
% Copyright 2019 Roddy Grieves

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ################################################################# %% INPUT ARGUMENTS CHECK
% deal with input variables
% if ~exist('var0','var') || isempty(var0);         error('%s needs input var0... exiting',mfilename);        end
% if ~exist('var1','var') || isempty(var1);         var1 = 10;                                                end
% if ~exist('var2','var') || isempty(var2);         var2 = 10;                                                end
% if ~exist('var3','var') || isempty(var3);         var3 = 10;                                                end

%% ##################################### Heading 2
%% #################### Heading 3
%% Heading 4
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% ################################################################# %% FUNCTION BODY
set(fh,'CurrentAxes',ah)
l1 = normr([-970 0 0]); 
l2 = normr([970 0 0]); 
l3 = normr([0 970 0]); 
l4 = normr([0 -970 0]); 
l5 = normr([0 0 970]); 
l6 = normr([0 0 -970]); 
l7 = normr([0 660 466.69]); 
l8 = normr([0 -660 -466.69]); 
l9 = normr([571.6 -330 466.69]); 
l10 = normr([-571.6 330 -466.69]); 
l11 = normr([-571.55 -330 466.69]); 
l12 = normr([571.55 330 -466.69]); 
if ~exist('lindx','var') || isempty(lindx);  lindx = 1:12;  end

switch maze
%% #################### Square  
    case {1} % square
        plotcube([7,7,1],[0 0 0],1,'b');
        daspect([1 1 1])
        colormap(gca,parula)
        view([30,22]);    
        hold on   

        adj = 7;
        lcol = 'k';
        lwid = 1;
        hold on;
        lins = {l1 l2 l3 l4 l5 l6 l7 l8 l9 l10 l11 l12};
        lsty = {'-','-','-','-','-','-',':',':',':',':',':',':',};
        orig = [3.5 3.5 .5];
        for ll = 1:length(lindx)
            lx = lindx(ll);
            lnow = lins{lx};
            line([orig(1) lnow(1)*adj+orig(1)],[orig(2) lnow(2)*adj+orig(2)],[orig(3) lnow(3)*adj+orig(3)],'Color',lcol,'LineStyle',lsty{ll},'LineWidth',lwid) % X left
        end
        
%% #################### Aligned lattice      
    case {2} % aligned
        [v1] = meshgrid(1:7);
        surf(v1,v1',ones(size(v1))); hold on;
        surf(v1,v1',ones(size(v1)).*7);
        surf(v1,ones(size(v1)),v1');
        surf(v1,ones(size(v1)).*7,v1',v1);
        surf(ones(size(v1)),v1,v1');
        surf(ones(size(v1)).*7,v1,v1');
        daspect([1 1 1])
        colormap(gca,parula)
        view([30,22]);    
        
        adj = 7;
        lcol = 'k';
        lwid = 1;
        hold on;
        lins = {l1 l2 l3 l4 l5 l6 l7 l8 l9 l10 l11 l12};
        lsty = {'-','-','-','-','-','-',':',':',':',':',':',':',};
        orig = [4 4 4];
        for ll = 1:length(lindx)
            lx = lindx(ll);
            lnow = lins{lx};
            line([orig(1) lnow(1)*adj+orig(1)],[orig(2) lnow(2)*adj+orig(2)],[orig(3) lnow(3)*adj+orig(3)],'Color',lcol,'LineStyle',lsty{ll},'LineWidth',lwid) % X left
        end

%% #################### Tilted lattice       
    case {3} % tilted
        rot_matZ = rotz(45);
        rot_matX = rotx(54.735);
        rot_matZ2 = rotz(60);
        [v1] = meshgrid(1:7);
        v2 = v1';
        xyz = [v1(:) v2(:) ones(size(v1(:)))];
        xyz = rot_matZ * xyz';
        xyz = (rot_matX * xyz);
        xyz = (rot_matZ2 * xyz)';        
        surf(reshape(xyz(:,1),size(v1)),reshape(xyz(:,2),size(v1)),reshape(xyz(:,3),size(v1))); hold on;
        daspect([1 1 1])
        xyz = [v1(:) v2(:) ones(size(v1(:))).*7];
        xyz = rot_matZ * xyz';
        xyz = (rot_matX * xyz);
        xyz = (rot_matZ2 * xyz)';                
        surf(reshape(xyz(:,1),size(v1)),reshape(xyz(:,2),size(v1)),reshape(xyz(:,3),size(v1))); hold on;
        xyz = [v1(:) ones(size(v1(:))) v2(:)];
        xyz = rot_matZ * xyz';
        xyz = (rot_matX * xyz);
        xyz = (rot_matZ2 * xyz)';                
        surf(reshape(xyz(:,1),size(v1)),reshape(xyz(:,2),size(v1)),reshape(xyz(:,3),size(v1))); hold on;
        xyz = [v1(:) ones(size(v1(:))).*7 v2(:)];
        xyz = rot_matZ * xyz';
        xyz = (rot_matX * xyz);
        xyz = (rot_matZ2 * xyz)';                
        surf(reshape(xyz(:,1),size(v1)),reshape(xyz(:,2),size(v1)),reshape(xyz(:,3),size(v1))); hold on;
        xyz = [ones(size(v1(:))) v1(:) v2(:)];
        xyz = rot_matZ * xyz';
        xyz = (rot_matX * xyz);
        xyz = (rot_matZ2 * xyz)';                
        surf(reshape(xyz(:,1),size(v1)),reshape(xyz(:,2),size(v1)),reshape(xyz(:,3),size(v1))); hold on;
        xyz = [ones(size(v1(:))).*7 v1(:) v2(:)];
        xyz = rot_matZ * xyz';
        xyz = (rot_matX * xyz);
        xyz = (rot_matZ2 * xyz)';                
        surf(reshape(xyz(:,1),size(v1)),reshape(xyz(:,2),size(v1)),reshape(xyz(:,3),size(v1))); hold on;
        daspect([1 1 1])
        colormap(gca,'parula')
        caxis([2 11])
        view([30,22]);    

        adj = 7;
        lcol = 'k';
        lwid = 1;
        hold on;
        lins = {l1 l2 l3 l4 l5 l6 l7 l8 l9 l10 l11 l12};
        lsty = {'-','-','-','-','-','-',':',':',':',':',':',':'};
        orig = [0 0 6.928];
        for ll = 1:length(lindx)
            lx = lindx(ll);
            lnow = lins{lx};
            line([orig(1) lnow(1)*adj+orig(1)],[orig(2) lnow(2)*adj+orig(2)],[orig(3) lnow(3)*adj+orig(3)],'Color',lcol,'LineStyle',lsty{ll},'LineWidth',lwid) % X left
        end
        
end








































































