function stats_and_bars(ds,gs,mvals,flnw,fsiz,pads)

% deal with input variables
inps = {'pads'};
vals = {'0.1'};
reqd = [0];
for ff = 1:length(inps)
    if ~exist(inps{ff},'var')
        if reqd(ff)
            error('ERROR: vargin %s missing... exiting',inps{ff});            
        end        
        eval([inps{ff} '=' vals{ff} ';']);
    end
end

gs(isnan(ds)) = [];
ds(isnan(ds)) = [];

g = unique(gs);
v = sum(gs==unique(gs)');
ng = numel(v);
hold on;
if numel(unique(v))==1 % if all the groups are the same size
    dat = reshape(ds,v(1),[]);
    [p,a,sts] = friedman(dat,1,'off');
    c = NaN;
    if p<=.05
        if ng == 2
                lh = addSIGBARS([1 2],nanmax(dat,[],1),p,pads,flnw,fsiz);    
        else
            [c,m,h,~] = multcompare(sts,'display','off','ctype','bonferroni');
            c;
            pindx = c(:,end);
            pvals = c(pindx<=.05,end);
            gvals = c(pindx<=.05,1:2);
            gvals = mat2cell(gvals,ones(size(gvals,1),1),2);
            if exist('mvals','var') && ~isempty(mvals)
                lh = addSIGBARS(cell2mat(gvals),mvals,pvals,pads,flnw,fsiz); 
            else
                lh = addSIGBARS(cell2mat(gvals),nanmax(dat,[],1),pvals,pads,flnw,fsiz);             
            end
        end
    end
    disp(sprintf('\tFriedman: X2(%d) = %.1f, p = %.5f, eta = %.5f    ',a{2,3},a{2,5},p,a{2,5}/sum(~isnan(ds))))
    disp(sprintf('\tPost-hoc: %s    ',mat2str(c(:,end)',6)));
    
else
    [p,a,sts] = kruskalwallis(ds,gs,'off');
    c = NaN;
    
    dat = NaN(1,ng);
    for i = 1:ng
        dat(i) = nanmax(ds(gs==g(i)));
    end
    
    if p<=.05    
        if ng == 2
            lh = addSIGBARS([1 2],dat,p,0.1,flnw,fsiz);    
        else
            [c,m,h,~] = multcompare(sts,'display','off','ctype','bonferroni');
            c;
            pindx = c(:,end);
            pvals = c(pindx<=.05,end);
            gvals = c(pindx<=.05,1:2);
            gvals = mat2cell(gvals,ones(size(gvals,1),1),2);
            if exist(mvals,'var') && ~isempty(mvals)
                lh = addSIGBARS(cell2mat(gvals),mvals,pvals,pads,flnw,fsiz); 
            else
                lh = addSIGBARS(cell2mat(gvals),nanmax(dat,[],1),pvals,pads,flnw,fsiz);             
            end
        end
    end
    disp(sprintf('\tKruskalwallis: X2(%d) = %.1f, p = %.5f, eta = %.5f     ',a{2,3},a{2,5},p,a{2,5}/sum(~isnan(ds))))
    disp(sprintf('\tPost-hoc: %s    ',mat2str(c(:,end)',6)));

end


for i = 1:ng
    disp(sprintf('\t\tMd = %.4f',nanmedian(ds(gs==g(i)))));
end



























